VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FormPartNoProp 
   Caption         =   "Part Number Property"
   ClientHeight    =   5730
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9510
   OleObjectBlob   =   "FormPartNoProp.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FormPartNoProp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'--------------------------------------------------------------------07/13/2005
' PartNoProperty.swb - Copyright 2005 Leonard Kikstra
'------------------------------------------------------------------------------
' V1.00 - 07/12/2005 - Released via website (Rushed to release)
' V1.01 - 07/13/2005 - Coded additional option checkboxes on userform
'------------------------------------------------------------------------------
Dim Bool            As Boolean
Dim Intg            As Integer
Dim Var             As Variant
Dim Lng             As Long
Dim Str             As String
Dim Dbl             As Double
Dim Counter         As Integer
Dim WorkDirectory   As String
Dim FileName        As String
Dim FileType        As String
Dim TypeNum         As Integer
Dim Title           As String
Dim DwgType         As String
Dim longstatus      As Long
Dim longstatus2     As Long
Dim longstat        As Long
Dim FileRO          As Boolean
Dim OpenRO          As Boolean
Dim SaveFlag        As Boolean
Dim PartNoPropName  As String
Dim Source          As String
Dim FileSys         As Object

Const Version = "V1.01"

Public Enum swDocumentTypes_e
        swDocNONE = 0       '  Used to be TYPE_NONE
        swDocPART = 1       '  Used to be TYPE_PART
        swDocASSEMBLY = 2   '  Used to be TYPE_ASSEMBLY
        swDocDRAWING = 3    '  Used to be TYPE_DRAWING
        swDocSDM = 4        '  Solid data manager.
End Enum

Public Enum swCustomInfoType_e
        swCustomInfoUnknown = 0
        swCustomInfoText = 30       '  VT_LPSTR
        swCustomInfoDate = 64       '  VT_FILETIME
        swCustomInfoNumber = 3      '  VT_I4
        swCustomInfoYesOrNo = 11    '  VT_BOOL
End Enum

Public Enum swOpenDocOptions_e
        swOpenDocOptions_Silent = &H1               '  Open document silently or not
        swOpenDocOptions_ReadOnly = &H2             '  Open document read only or not
        swOpenDocOptions_ViewOnly = &H4             '  Open document view only or not
        swOpenDocOptions_RapidDraft = &H8           '  Convert document to RapidDraft format or not (drawings only)
        swOpenDocOptions_LoadModel = &H10           '  Load detached models automatically or not (drawings only)
        swOpenDocOptions_AutoMissingConfig = &H20   '  Automatically handle missing configs of drawing views (drawings only)
End Enum

Public Enum swSaveAsOptions_e
        swSaveAsOptions_Silent = &H1                '  Save document silently or not
        swSaveAsOptions_Copy = &H2                  '  Save document as a copy or not
        swSaveAsOptions_SaveReferenced = &H4        '  Save referenced documents or not (drawings and parts only)
        swSaveAsOptions_AvoidRebuildOnSave = &H8    '  Avoid rebuild on Save or SaveAs, if swSaveAsOptions_Silent
        swSaveAsOptions_UpdateInactiveViews = &H10  '  Update views of inactive sheets, if swSaveAsOptions_Silent
        swSaveAsOptions_OverrideSaveEmodel = &H20   '  Override system setting for saving emodel data of document
        swSaveAsOptions_SaveEmodelData = &H40       '  If OverrideSaveEmodel is True, use this as the value instead
End Enum

'------------------------------------------------------------------------------
' This function will count the occurance of "stringToFind" inside "theString".
'------------------------------------------------------------------------------
Function ParseStringCount(theString As String, stringToFind As String)
  Dim CountPosition As Long
  CountPosition = 1
  CountNum = 0
  While CountPosition > 0
    CountPosition = InStr(1, theString, stringToFind)
    If CountPosition <> 0 Then    ' Which characters do we keep
      theString = Mid(theString, CountPosition + Len(stringToFind))
      CountNum = CountNum + 1
    End If
  Wend
  ParseStringCount = LTrim(CountNum)
End Function

'------------------------------------------------------------------------------
' This function will locate the occurance of "stringToFind" inside "theString".
' From that position, it will return the remaining characters
' based on the 'FirstLast' variable passed into this routine.
'   FirstLast = 0       Get first occurrance and return text before
'               1       Get last occurrance and return text after
'------------------------------------------------------------------------------
Function reverseParseString(theString As String, stringToFind As String, _
                            FirstLast As Boolean)
    Dim slashPosition As Long
    slashPosition = 1
    While slashPosition > 0
      slashPosition = InStr(1, theString, stringToFind)
      If slashPosition <> 0 Then    ' Which characters do we keep
        If FirstLast = True Then    '   0 = Return text before
                                    '   1 = Return text after
          theString = Mid(theString, slashPosition + Len(stringToFind))
        Else
          theString = Mid(theString, 1, slashPosition - 1)
        End If
         
      End If
    Wend
    reverseParseString = theString
End Function

'------------------------------------------------------------------------------
' This function will locate the occurance of "stringToFind" inside "theString".
'   Occur  = 0       Get first occurrance
'            1       Get last occurrance
' From that position, it will return text based on the 'Retrieve' variable.
'   StrRet = 0       Get text before
'            1       Get text after
'            2       If no occurrance found, return blank
'------------------------------------------------------------------------------
Function NewParseString(theString As String, stringToFind As String, _
                            Occur As Boolean, StrRet As Integer)
  Location = 0
  TempLoc = 0
  PosCount = 1
  While PosCount < Len(theString)
    TempLoc = InStr(PosCount, theString, stringToFind)
    If TempLoc <> 0 Then
      If Occur = 0 Then
        If Location = 0 Then
          Location = TempLoc
        End If
      Else
        Location = TempLoc
      End If
      PosCount = TempLoc + 1
    Else
      PosCount = Len(theString)
    End If
  Wend
  If Location <> 0 Then
    If StrRet = 0 Then
      theString = Mid(theString, 1, Location - 1)
    Else
      theString = Mid(theString, Location + Len(stringToFind))
    End If
  ElseIf StrRet = 2 Then
    theString = ""
  End If
  NewParseString = theString
End Function

'------------------------------------------------------------------------------
' Change attributes for specific file
'------------------------------------------------------------------------------
Sub FileAttrib(FileName, Attrib, SetClear)
  ' SetClear values:    1 = set     0  = Clear
' Set FileSys = CreateObject("Scripting.FileSystemObject")
  Set FileSpec = FileSys.GetFile(FileName)
  If SetClear = 1 Then
    ' Set Attrib bit
    FileSpec.Attributes = FileSpec.Attributes Or Attrib
  Else
    ' Clear Attrib bit
    FileSpec.Attributes = FileSpec.Attributes And (Not Attrib)
  End If
  ' 0  Normal       4  System
  ' 1  ReadOnly     32 Archive
  ' 2  Hidden
End Sub

'------------------------------------------------------------------------------
' Read attributes for specific file
'------------------------------------------------------------------------------
Sub FileAttribRead(FileName, Attrib)
' Set FileSys = CreateObject("Scripting.FileSystemObject")
  Set FileSpec = FileSys.GetFile(FileName)
  If FileSpec.Attributes And Attrib Then
    FileRO = True
  Else
    FileRO = False
  End If
  ' 0  Normal       4  System
  ' 1  ReadOnly     32 Archive
  ' 2  Hidden
End Sub

'------------------------------------------------------------------------------
' Select parts based on file extension
'------------------------------------------------------------------------------
Private Sub CommandSelectParts_Click()
  SelectFiles ("prt")
End Sub

'------------------------------------------------------------------------------
' Select assemblies based on file extension
'------------------------------------------------------------------------------
Private Sub CommandSelectAssys_Click()
  SelectFiles ("asm")
End Sub

'------------------------------------------------------------------------------
' Select drawings based on file extension
'------------------------------------------------------------------------------
Private Sub CommandSelectDraw_Click()
  SelectFiles ("drw")
End Sub

'------------------------------------------------------------------------------
' Traverse thru list and select files based on file extension
'------------------------------------------------------------------------------
Private Sub SelectFiles(FTyp)
  For i = 0 To ListBoxOutput.ListCount - 1
    If UCase(Right$(ListBoxOutput.List(i, 0), Len(FTyp))) = UCase(FTyp) Then _
      ListBoxOutput.Selected(i) = True
  Next i
End Sub

'------------------------------------------------------------------------------
' Unselect parts based on file extension
'------------------------------------------------------------------------------
Private Sub CommandClearParts_Click()
  ClearFiles ("prt")
End Sub

'------------------------------------------------------------------------------
' Unselect assemblies based on file extension
'------------------------------------------------------------------------------
Private Sub CommandClearAssy_Click()
  ClearFiles ("asm")
End Sub

'------------------------------------------------------------------------------
' Unselect drawings based on file extension
'------------------------------------------------------------------------------
Private Sub CommandClearDraw_Click()
  ClearFiles ("drw")
End Sub

'------------------------------------------------------------------------------
' Traverse thru list and unselect files based on file extension
'------------------------------------------------------------------------------
Private Sub ClearFiles(FTyp)
  For i = 0 To ListBoxOutput.ListCount - 1
    If UCase(Right$(ListBoxOutput.List(i, 0), Len(FTyp))) = UCase(FTyp) Then _
      ListBoxOutput.Selected(i) = False
  Next i
End Sub

'------------------------------------------------------------------------------
' Read model descriptions (bypass drawings)
'------------------------------------------------------------------------------
Private Sub CommandDescriptions_Click()
  MyControls False
  Counter = 0
  For Counter = 0 To ListBoxOutput.ListCount - 1        ' Number of filenames
    FileName = ListBoxOutput.List(Counter, 0)
    If UCase(Right$(ListBoxOutput.List(Counter, 0), 3)) <> UCase("DRW") Then _
      OpenDocument FileName                             ' open all but drawings
    Description = Document.CustomInfo("DESCRIPTION")
    ShowInfoUpdate Counter, FileName, Description
    Set Document = Nothing
    swApp.CloseDoc FileName
  Next Counter
  PartNoProp1.CloseAll
  SimpleStatus "Select files then click [Print] to continue."
  MyControls True
End Sub

'------------------------------------------------------------------------------
' Get list of documents that are available to work with
'------------------------------------------------------------------------------
Private Sub Preview()
  MyControls False
  Counter = 0
  AddToFileList ("*.sldprt")       ' gets file list
  AddToFileList ("*.sldasm")       ' gets file list
  AddToFileList ("*.slddrw")       ' gets file list
  AddToFileList ("*.prt")          ' gets file list
  AddToFileList ("*.asm")          ' gets file list
  AddToFileList ("*.drw")          ' gets file list
  For x = 0 To ListBoxOutput.ListCount - 2         ' Number of passes
    For y = 0 To ListBoxOutput.ListCount - 2       ' Pass thru each row
      If ListBoxOutput.List(y, 0) _
         > ListBoxOutput.List(y + 1, 0) Then       ' If greater, re-order
        Temp = ListBoxOutput.List(y, 0)            ' Re-order entries
        ListBoxOutput.List(y, 0) = ListBoxOutput.List(y + 1, 0)
        ListBoxOutput.List(y + 1, 0) = Temp
      End If                                        ' Re-order check
    Next y                                          ' Pass thru each row
  Next x                                            ' Number of passes - row qty
  SimpleStatus "Select files then click [Print] to continue."
  MyControls True
End Sub

'------------------------------------------------------------------------------
' Add files to list
'------------------------------------------------------------------------------
Private Sub AddToFileList(Extension)
  FileName = Dir(WorkDirectory + Extension)         ' gets file list
  Do While FileName <> ""
    ShowInfoAdd FileName
    FileName = Dir
  Loop
End Sub

'------------------------------------------------------------------------------
' Process selected documents in file list
'------------------------------------------------------------------------------
Private Sub CmdProcess_Click()
  MyControls False
  ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ' Let's go to work.
  ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  Dim retstr As String
  SimpleStatus "Working..."
  Counter = 0
  Open WorkDirectory & "PartNoProp.txt" For Append As #1
  ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ' Record options at runtime.
  ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  Print #1, "--------------------------------------"
  Print #1, "  Option(s) Selected:"
  If CheckBoxReadOnly = True Then _
    Print #1, "      * Change ReadOnly files."
  If CheckBoxWarnDifferent = True Then _
    Print #1, "      * Warn if existing value is different."
  If CheckBoxExistingOverwrite = True Then _
    Print #1, "      * Overwrite existing values."
  Print #1, "--------------------------------------"
  Print #1, "The following files were corrected on: "; Date
  For Counter = 0 To ListBoxOutput.ListCount - 1
    If ListBoxOutput.Selected(Counter) = True Then
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ' Item selected, let's check it out.
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      FileName = ListBoxOutput.List(Counter, 0)
      ShowInfoUpdate Counter, FileName, "", "Checking status"
      FileAttribRead WorkDirectory + FileName, 1            ' is file ReadOnly?
      If FileRO = True Then                                 ' ReadOnly, change
        If CheckBoxReadOnly = True Then
          ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          ' File is ReadOnly, change to ReadWrite and set FileRO flag.
          ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          ShowInfoUpdate Counter, FileName, "", "Setting ReadWrite"
          FileAttrib WorkDirectory + FileName, 1, 0         ' Change attrib RW
        Else
          ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          ' User does not want to change ReadOnly files, skip it.
          ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          ShowInfoUpdate Counter, FileName, Description, "Skipped. ReadOnly"
          GoTo FileSkipped
        End If
      End If
      ShowInfoUpdate Counter, FileName, "", "Opening file"
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ' Open file so it can be chcked.
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      OpenDocument FileName
      Description = Document.CustomInfo("DESCRIPTION")
      ShowInfoUpdate Counter, FileName, Description, "Checking file"
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ' For PartNoPropName custom file property, check for valid value.
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      Tempval = LTrim(RTrim(Document.GetCustomInfoValue("", PartNoPropName)))
      ModelName = NewParseString(UCase(Document.GetTitle), ".SLD", 0, 0)
      If Tempval <> ModelName Then  ' Is property properly set?
        ' Property is not properly set
        ' Is property blank?
        If Tempval = "" Then        ' Check value, if it is blank,
          ' Property is equal to blank/nothing.  Must mark to set correctly.
          Tempval = ModelName       ' then make it valid
          ModFlag = True            ' Set modify flag
        Else
          ' Property is not blank.  Should we warn user?
          If CheckBoxWarnDifferent = True Then
            vbResult = MsgBox("Custom property value does not match file name." _
                            & Chr$(13) _
                            & Chr$(13) & "Description:    " & Description _
                            & Chr$(13) _
                            & Chr$(13) & "Current value:  " & Tempval _
                            & Chr$(13) & "Expected value: " & ModelName _
                            & Chr$(13) _
                            & Chr$(13) _
                            & "Should this be corrected?", vbYesNo)
            If vbResult = vbYes Then ModFlag = True                 ' Set flag
          Else
            ' No warning to user, should we overwrite anyways?
            If CheckBoxExistingOverwrite = True Then ModFlag = True ' Set flag
          End If
        End If
      End If                        ' Is property properly set
      ' If marked for modify, then set correctly.
      If ModFlag = True Then        ' Modify/update property
        ' Attempt to add property.  Only works if it does not already exist
        Document.AddCustomInfo3 "", PartNoPropName, swCustomInfoText, ""
        Document.CustomInfo2("", PartNoPropName) = ModelName  ' Change prop
        ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        ' File was modified, we need to save corrected file and tell user.
        '   'ShowInfoUpdate'    Displays this info on screen during runtime.
        '   'Print #1'          Adds this info to log file for later viewing.
        '                       Log file should only show files modified.
        ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        Document.Save2 swSaveAsOptions_Silent               ' Save the document
        Print #1, ""
        Print #1, FileName & ", " & Description
        If FileRO = True Then                               ' ReadOnly, change
          ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          ' Log that we changed a ReadOnly file.
          ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          ShowInfoUpdate Counter, FileName, Description, "Complete - ReadOnly"
          Print #1, "  - File attribute was/is ReadOnly"
        Else
          ' File was not ReadOnly, but still modified.  Tell user on screen.
          ShowInfoUpdate Counter, FileName, Description, "Completed - Saved"
        End If                      ' Document loaded RO
        Print #1, "  - "; PartNoPropName; " Custom Property Changed."
      Else
        ShowInfoUpdate Counter, FileName, Description, "Skipped. No Change."
      End If
      Set Document = Nothing        ' Clear Document object
    End If                          ' File selected
FileSkipped:
    PartNoProp1.CloseAll
    If FileRO = True Then
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ' If file was originally ReadOnly, change back to attrib back to ReadOnly
      ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      FileAttrib WorkDirectory + FileName, 1, 1
    End If                          ' Document loaded
    ' Done with this component, clear flags if set
    FileRO = False                  ' Clear FileRO flag
    ModFlag = False                 ' Clear modify flag
    Description = ""                ' Clear Description
  Next Counter
  Print #1, ""
  Print #1, "--------------------------------------"
  Print #1, ""
  Close #1  ' or just Close       ' ensure log file is closed when done.
  SimpleStatus "Completed. Click [Close] to exit."
  CommandClose.Enabled = True
  ListBoxOutput.Enabled = True
  Me.Repaint
End Sub

'------------------------------------------------------------------------------
' Determine document type based on file extension, then open file.
'------------------------------------------------------------------------------
Private Sub OpenDocument(FName)
  Dim TempFileName As String
  TempFileName = FName & ""
  FType = UCase(reverseParseString(TempFileName, ".", 1))
  If (FType = "SLDPRT") Or (FType = "PRT") Then MyFileType = 1
  If (FType = "SLDASM") Or (FType = "ASM") Then MyFileType = 2
  If (FType = "SLDDRW") Or (FType = "DRW") Then MyFileType = 3
  Set Document = swApp.OpenDoc6(WorkDirectory & FName, _
                                  MyFileType, swOpenDocOptions_Silent, _
                                  "Default", longstatus, longstat)
End Sub

'------------------------------------------------------------------------------
' Displays text in the LabelStatus on the form
'------------------------------------------------------------------------------
Sub SimpleStatus(Stat)
  LabelStatus.Caption = " " + Stat
  Me.Repaint
End Sub

'------------------------------------------------------------------------------
' Use this routine to add items to the ListBoxOutput.
' This routine maintains the position counter for ListBoxOutput.
'------------------------------------------------------------------------------
Sub ShowInfoAdd(StatText0, Optional StatText1 = "", _
           Optional StatText2 = "", Optional StatText3 = "", _
           Optional StatText4 = "", Optional StatText5 = "")
  If StatText0 <> "" Then _
        ListBoxOutput.AddItem StatText0
  If StatText1 <> "" And ListBoxOutput.ColumnCount >= 1 Then _
        ListBoxOutput.List(Counter, 1) = StatText1
  If StatText2 <> "" And ListBoxOutput.ColumnCount >= 2 Then _
        ListBoxOutput.List(Counter, 2) = StatText2
  If StatText3 <> "" And ListBoxOutput.ColumnCount >= 3 Then _
        ListBoxOutput.List(Counter, 3) = StatText3
  If StatText4 <> "" And ListBoxOutput.ColumnCount >= 4 Then _
        ListBoxOutput.List(Counter, 4) = StatText4
  If StatText5 <> "" And ListBoxOutput.ColumnCount >= 5 Then _
        ListBoxOutput.List(Counter, 5) = StatText5
  ListBoxOutput.ListIndex = Counter
  Counter = Counter + 1
  SimpleStatus StatText0 + " " + StatText1 + " " + StatText2 + " " + _
               StatText3 + " " + StatText4 + " " + StatText5
  Repaint
End Sub

'------------------------------------------------------------------------------
' Use this routine to update a row in the ListBoxOutput.
' This routine requires the calling routines to maintain and
' identify the correct counter for ListBoxOutput
'------------------------------------------------------------------------------
Sub ShowInfoUpdate(Counter, StatText0, Optional StatText1 = "", _
           Optional StatText2 = "", Optional StatText3 = "", _
           Optional StatText4 = "", Optional StatText5 = "")
  If StatText0 <> "" Then _
        ListBoxOutput.List(Counter, 0) = StatText0
  If StatText1 <> "" And ListBoxOutput.ColumnCount >= 1 Then _
        ListBoxOutput.List(Counter, 1) = StatText1
  If StatText2 <> "" And ListBoxOutput.ColumnCount >= 2 Then _
        ListBoxOutput.List(Counter, 2) = StatText2
  If StatText3 <> "" And ListBoxOutput.ColumnCount >= 3 Then _
        ListBoxOutput.List(Counter, 3) = StatText3
  If StatText4 <> "" And ListBoxOutput.ColumnCount >= 4 Then _
        ListBoxOutput.List(Counter, 4) = StatText4
  If StatText5 <> "" And ListBoxOutput.ColumnCount >= 5 Then _
        ListBoxOutput.List(Counter, 5) = StatText5
  ListBoxOutput.ListIndex = Counter
  SimpleStatus StatText0 + " " + StatText1 + " " + StatText2 + " " + _
               StatText3 + " " + StatText4 + " " + StatText5
  Repaint
End Sub

'------------------------------------------------------------------------------
' Enable/disable controls
'------------------------------------------------------------------------------
Private Sub MyControls(Mode As Boolean)
  CommandDescriptions.Enabled = Mode
  CommandSelectParts.Enabled = Mode
  CommandSelectAssys.Enabled = Mode
  CommandClearParts.Enabled = Mode
  CommandClearAssy.Enabled = Mode
  FrameSelect.Enabled = Mode
  FrameClear.Enabled = Mode
  FrameOptions.Enabled = Mode
  CmdProcess.Enabled = Mode
  CommandClose.Enabled = Mode
  CheckBoxReadOnly.Enabled = Mode
  ListBoxOutput.Enabled = Mode
  If Mode = True Then
    CheckBoxReadOnly.Locked = False
  Else
    CheckBoxReadOnly.Locked = True
  End If
End Sub
  
'------------------------------------------------------------------------------
' We are done!
'------------------------------------------------------------------------------
Private Sub CommandClose_Click()
  End
End Sub

'------------------------------------------------------------------------------
' Read and set PartNumber property name.
'------------------------------------------------------------------------------
Private Sub ReadOptions()
  Open Source For Input As #1                           ' Open source file.
  Do While Not EOF(1)                                   ' Loop until end file.
    Input #1, Reader                                    ' Read data line.
    If (UCase(Left$(Reader, 15)) = UCase("PartNoPropName=")) Then
      PartNoPropName = LTrim(RTrim(Mid$(Reader, 16)))   ' Set property name var
    ElseIf (UCase(Left$(Reader, 16)) = UCase("PartNoPropName =")) Then
      PartNoPropName = LTrim(RTrim(Mid$(Reader, 17)))   ' Set property name var
    Else
      MsgBox "Setting 'PartNoPropName=' not found in configuration file." & Chr$(13) & Chr$(13) _
             & "Using 'PartNumber' as part number property."
      PartNoPropName = "PartNumber"
    End If
EndOptionRead:
  Loop
  Close #1    ' Close file.
End Sub

'------------------------------------------------------------------------------
' Let's get started
'------------------------------------------------------------------------------
Private Sub UserForm_Initialize()
  Set FileSys = CreateObject("Scripting.FileSystemObject")
  Me.Caption = Me.Caption + Version
  WorkDirectory = swApp.GetCurrentWorkingDirectory
  LabelWorkDir.Caption = LabelWorkDir.Caption & " " & WorkDirectory
  Source = swApp.GetCurrentMacroPathName                ' Macro filename
  Source = Left$(Source, Len(Source) - 3) + "ini"       ' Source filename
  Set FileSys = CreateObject("Scripting.FileSystemObject")
  If FileSys.FileExists(Source) Then                        ' Source exist?
    ReadOptions
  Else
    MsgBox "No configuration file found." & Chr$(13) & Chr$(13) _
           & "Using 'PartNumber' as part number property."
    PartNoPropName = "PartNumber"
  End If
  TextBoxPartNoPropName = PartNoPropName
  Preview
End Sub

